#!/usr/bin/python3

def xor(x, y):
    return x and not y or not x and y

def right(d113, d114, i101, mwp):
    return not ((i101 and not (d114 and mwp)) and xor(d113, d114))

def wrong(d113, d114, i101, mwp):
    a_part = not (xor(d113, d114) and i101)
    b_part = (d113 and i101) and not (d114 and i101)
    return (mwp or a_part) and not (mwp and b_part)


print('d113 d114 i101 mwp right opt.'.replace(' ', '\t'))
for d113 in [False, True]:
    for d114 in [False, True]:
        for i101 in [False, True]:
            for mwp in [False, True]:
                print(d113, d114, i101, mwp, right(d113, d114, i101, mwp), wrong(d113, d114, i101, mwp), sep='\t')




# .glue eq.e111 = dc.d114 misc.mwp nand init.i101 and dc.d113 dc.d114 xor nand
#  optimized: essentially A Mwp OR B Mwp NAND AND,
#; So when Mwp is high, B controls inversely, Mwp is low, A controls directly.
#; The logic solver worked out A and B for this.
# The optimization only gets us to 2.1 ns, but it's at least something.
# ;.glue eq.e111 = dc.d113 dc.d114 xor init.i101 nand misc.mwp or 
# dc.d113 init.i101 and dc.d114 init.i101 nand and and
